--On ne surveille pas la cration des contacts, car elle intervient  la premire connexion de l'utilisateur quand il est totalement anonyne
--On suit les contacts  partir du moment ou ils s'enregistrent, donc modification sur l'email

IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.CustomerUpdated_dyncrm'))
EXEC dbo.sp_executesql @statement = N'CREATE TRIGGER dbo.CustomerUpdated_dyncrm ON dbo.Customer AFTER UPDATE AS SELECT NULL'
GO

ALTER TRIGGER dbo.CustomerUpdated_dyncrm 
   ON  dbo.Customer 
   AFTER UPDATE
AS 
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;


	MERGE dbo.DynamicsCrmEventQueue AS target
	--Check that it really has changed
	USING (SELECT inserted.Id, 'CONTACT', 'U', CURRENT_TIMESTAMP FROM inserted JOIN deleted ON inserted.Id = deleted.Id AND inserted.Email <> deleted.Email) AS source (EntityId, EntityType, EventType, CreatedOnUtc)		
	ON (target.EntityId = source.EntityId AND target.EntityType = source.EntityType)
	
	WHEN MATCHED 
	THEN UPDATE SET target.CreatedOnUtc = GETDATE()
	
	WHEN NOT MATCHED THEN	
    INSERT (EntityId, EntityType, EventType, CreatedOnUtc)
    VALUES (source.EntityId, source.EntityType, source.EventType, source.CreatedOnUtc);
END
GO







IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.CustomerAttributeInserted_dyncrm'))
EXEC dbo.sp_executesql @statement = N'CREATE TRIGGER dbo.CustomerAttributeInserted_dyncrm ON dbo.CustomerAttribute AFTER INSERT AS SELECT NULL'
GO

ALTER TRIGGER dbo.CustomerAttributeInserted_dyncrm 
   ON  dbo.CustomerAttribute 
   AFTER INSERT
AS 
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;


	MERGE dbo.DynamicsCrmEventQueue AS target
	--Looking for some inserts only
	USING (SELECT inserted.CustomerId, 'CONTACT', 'U', CURRENT_TIMESTAMP FROM inserted WHERE [key] IN ('FirstName', 'LastName', 'Gender', 'DateOfBirth')) AS source (EntityId, EntityType, EventType, CreatedOnUtc)		
	ON (target.EntityId = source.EntityId AND target.EntityType = source.EntityType)
	
	WHEN MATCHED 
	THEN UPDATE SET target.CreatedOnUtc = GETDATE()
	
	WHEN NOT MATCHED THEN
    INSERT (EntityId, EntityType, EventType, CreatedOnUtc)
    VALUES (source.EntityId, source.EntityType, source.EventType, source.CreatedOnUtc);
    
    
 --   MERGE dbo.DynamicsCrmEventQueue AS target
	--USING (SELECT inserted.CustomerId, 'ACCOUNT', 'U', CURRENT_TIMESTAMP FROM inserted WHERE [key] IN ('FirstName', 'LastName', 'Company')) AS source (EntityId, EntityType, EventType, CreatedOnUtc)		
	--ON (target.EntityId = source.EntityId AND target.EntityType = source.EntityType)
	
	--WHEN MATCHED 
	--THEN UPDATE SET target.CreatedOnUtc = GETDATE()
	
	--WHEN NOT MATCHED THEN	
 --   INSERT (EntityId, EntityType, EventType, CreatedOnUtc)
 --   VALUES (source.EntityId, source.EntityType, source.EventType, source.CreatedOnUtc);

END
GO


IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.CustomerAttributeUpdated_dyncrm'))
EXEC dbo.sp_executesql @statement = N'CREATE TRIGGER dbo.CustomerAttributeUpdated_dyncrm ON dbo.CustomerAttribute AFTER UPDATE AS SELECT NULL'
GO

ALTER TRIGGER dbo.CustomerAttributeUpdated_dyncrm 
   ON  dbo.CustomerAttribute 
   AFTER UPDATE
AS 
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;


	MERGE dbo.DynamicsCrmEventQueue AS target
	--Looking for some updates only and check that it really has changed
	USING (
		SELECT inserted.CustomerId, 'CONTACT', 'U', CURRENT_TIMESTAMP 
		FROM inserted JOIN deleted ON inserted.Id = deleted.Id 
		AND inserted.Value <> deleted.Value WHERE inserted.[key] IN ('FirstName', 'LastName', 'Gender', 'DateOfBirth')
	) AS source (EntityId, EntityType, EventType, CreatedOnUtc)		
	ON (target.EntityId = source.EntityId AND target.EntityType = source.EntityType)
	
	WHEN MATCHED 
	THEN UPDATE SET target.CreatedOnUtc = GETDATE()
	
	WHEN NOT MATCHED THEN	
    INSERT (EntityId, EntityType, EventType, CreatedOnUtc)
    VALUES (source.EntityId, source.EntityType, source.EventType, source.CreatedOnUtc);
    
    
 --   MERGE dbo.DynamicsCrmEventQueue AS target
	--USING (SELECT inserted.CustomerId, 'ACCOUNT', 'U', CURRENT_TIMESTAMP FROM inserted WHERE [key] IN ('FirstName', 'LastName', 'Company')) AS source (EntityId, EntityType, EventType, CreatedOnUtc)		
	--ON (target.EntityId = source.EntityId AND target.EntityType = source.EntityType)
	
	--WHEN MATCHED 
	--THEN UPDATE SET target.CreatedOnUtc = GETDATE()
	
	--WHEN NOT MATCHED THEN	
 --   INSERT (EntityId, EntityType, EventType, CreatedOnUtc)
 --   VALUES (source.EntityId, source.EntityType, source.EventType, source.CreatedOnUtc);

END
GO






IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.NewsLetterSubscriptionInserted_dyncrm'))
EXEC dbo.sp_executesql @statement = N'CREATE TRIGGER dbo.NewsLetterSubscriptionInserted_dyncrm ON dbo.[NewsLetterSubscription] AFTER INSERT AS SELECT NULL'
GO

ALTER TRIGGER dbo.NewsLetterSubscriptionInserted_dyncrm 
   ON  dbo.[NewsLetterSubscription] 
   AFTER INSERT
AS 
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;


	MERGE dbo.DynamicsCrmEventQueue AS target
	--Looking for some inserts only
	USING (SELECT inserted.Id, 'NEWSLETTERSUBS', 'I', CURRENT_TIMESTAMP FROM inserted) AS source (EntityId, EntityType, EventType, CreatedOnUtc)		
	ON (target.EntityId = source.EntityId AND target.EntityType = source.EntityType)
	
	WHEN MATCHED 
	THEN UPDATE SET target.CreatedOnUtc = GETDATE()
	
	WHEN NOT MATCHED THEN
    INSERT (EntityId, EntityType, EventType, CreatedOnUtc)
    VALUES (source.EntityId, source.EntityType, source.EventType, source.CreatedOnUtc);
    
    
END
GO

IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.NewsLetterSubscriptionUpdated_dyncrm'))
EXEC dbo.sp_executesql @statement = N'CREATE TRIGGER dbo.NewsLetterSubscriptionUpdated_dyncrm ON dbo.[NewsLetterSubscription] AFTER UPDATE AS SELECT NULL'
GO

ALTER TRIGGER dbo.NewsLetterSubscriptionUpdated_dyncrm 
   ON  dbo.[NewsLetterSubscription] 
   AFTER UPDATE
AS 
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;


	MERGE dbo.DynamicsCrmEventQueue AS target
	--Check that it really has changed
	USING (SELECT inserted.Id, 'NEWSLETTERSUBS', 'U', CURRENT_TIMESTAMP FROM inserted JOIN deleted ON inserted.Id = deleted.Id) AS source (EntityId, EntityType, EventType, CreatedOnUtc)		
	ON (target.EntityId = source.EntityId AND target.EntityType = source.EntityType)
	
	WHEN MATCHED 
	THEN UPDATE SET target.CreatedOnUtc = GETDATE()
	
	WHEN NOT MATCHED THEN	
    INSERT (EntityId, EntityType, EventType, CreatedOnUtc)
    VALUES (source.EntityId, source.EntityType, source.EventType, source.CreatedOnUtc);
END
GO





IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.OrderInserted_dyncrm'))
EXEC dbo.sp_executesql @statement = N'CREATE TRIGGER dbo.OrderInserted_dyncrm ON dbo.[Order] AFTER INSERT AS SELECT NULL'
GO

ALTER TRIGGER dbo.OrderInserted_dyncrm 
   ON  dbo.[Order] 
   AFTER INSERT
AS 
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;


	MERGE dbo.DynamicsCrmEventQueue AS target
	--Looking for some inserts only
	USING (SELECT inserted.Id, 'SALESORDER', 'I', CURRENT_TIMESTAMP FROM inserted) AS source (EntityId, EntityType, EventType, CreatedOnUtc)		
	ON (target.EntityId = source.EntityId AND target.EntityType = source.EntityType)
	
	WHEN MATCHED 
	THEN UPDATE SET target.CreatedOnUtc = GETDATE()
	
	WHEN NOT MATCHED THEN
    INSERT (EntityId, EntityType, EventType, CreatedOnUtc)
    VALUES (source.EntityId, source.EntityType, source.EventType, source.CreatedOnUtc);
    
    
END
GO

IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'dbo.OrderUpdated_dyncrm'))
EXEC dbo.sp_executesql @statement = N'CREATE TRIGGER dbo.OrderUpdated_dyncrm ON dbo.[Order] AFTER UPDATE AS SELECT NULL'
GO

ALTER TRIGGER dbo.OrderUpdated_dyncrm 
   ON  dbo.[Order] 
   AFTER UPDATE
AS 
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;


	MERGE dbo.DynamicsCrmEventQueue AS target
	--Check that it really has changed
	USING (SELECT inserted.Id, 'SALESORDER', 'U', CURRENT_TIMESTAMP FROM inserted JOIN deleted ON inserted.Id = deleted.Id) AS source (EntityId, EntityType, EventType, CreatedOnUtc)		
	ON (target.EntityId = source.EntityId AND target.EntityType = source.EntityType)
	
	WHEN MATCHED 
	THEN UPDATE SET target.CreatedOnUtc = GETDATE()
	
	WHEN NOT MATCHED THEN	
    INSERT (EntityId, EntityType, EventType, CreatedOnUtc)
    VALUES (source.EntityId, source.EntityType, source.EventType, source.CreatedOnUtc);
END
GO



