﻿using System.Collections.Generic;
using Nop.Plugin.Misc.DynamicsCrm.Data;

namespace Nop.Plugin.Misc.DynamicsCrm.Services
{
    public interface IDynamicsCrmEventQueueingService
    {
        /// <summary>
        /// Deletes the specified record.
        /// </summary>
        /// <param name="record">The record.</param>
        void Delete(DynamicsCrmEventQueue record);

        /// <summary>
        /// Inserts the specified record.
        /// </summary>
        /// <param name="record">The record.</param>
        void Insert(DynamicsCrmEventQueue record);

        /// <summary>
        /// Queues all contacts.
        /// </summary>
        void QueueAllContacts();

        /// <summary>
        /// Queues all orders.
        /// </summary>
        void QueueAllOrders();

        /// <summary>
        /// Reads the list.
        /// </summary>
        /// <returns>Result</returns>
        IList<DynamicsCrmEventQueue> GetAll();
    }
}